
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>.net(C#)在Access数据库中执行sql脚本 / 憋错料</title>

    <meta name="description" content=".net(C#)在Access数据库中执行sql脚本 自己写的一个工具类,主要是业务场景的需要. 主要有两个功能: ①执行包含sql语句的字符串 ②执行包含sql语句的文件 调用方式 1 /// &lt;summary&gt; 2 /// 执行sql语句 3 /// &lt;/summary&gt; 4 /// &lt;param name=&quot;sql&quot;&gt;需要执行的sql语句&lt;/param&gt; 5 public bool ExecuteSql(string sql, ref string errorMsg) 6 { ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">.net(C#)在Access数据库中执行sql脚本</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>自己写的一个工具类，主要是业务场景的需要。</p>
<p>主要有两个功能：</p>
<p>①执行包含sql语句的字符串</p>
<p>②执行包含sql语句的文件</p>
<p>调用方式</p>
<p></p>

<pre> 1 /// &lt;summary&gt;
 2         /// 执行sql语句
 3         /// &lt;/summary&gt;
 4         /// &lt;param name="sql"&gt;需要执行的sql语句&lt;/param&gt;
 5         public bool ExecuteSql(string sql, ref string errorMsg)
 6         {
 7             SetConnOpen();
 8             string[] sqls = serializeSql(sql);
 9             OleDbTransaction tran = conn.BeginTransaction();
10             try
11             {
12                 comm = new OleDbCommand();
13                 comm.Transaction = tran;
14                 comm.Connection = conn;
15                 foreach (string s in sqls)
16                 {
17                     var temps = s.Trim().Replace("\r\n", "");
18                     if (!string.IsNullOrEmpty(temps))
19                     {
20                         comm.CommandText = temps;
21                         comm.ExecuteNonQuery();
22                     }
23                 }
24                 tran.Commit();
25                 return true;
26             }
27             catch(Exception ex)
28             {
29                 tran.Rollback();
30                 errorMsg = ex.Message;
31                 return false;
32             }
33             finally
34             {
35                 conn.Close();
36             }
37         }</pre>
<p>执行包含sql语句的字符串</p>
<p></p>

<pre>/// &lt;summary&gt;
        /// 从sql脚本文件执行
        /// &lt;/summary&gt;
        /// &lt;param name="sqlFilePath"&gt;sql脚本文件的路径&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool ExecuteSqlByFile(string sqlFilePath,ref string errorMsg)
        {
            if(!File.Exists(sqlFilePath))
            {
                throw new FileNotFoundException("未找到该sql脚本，请检查路径是否错误");
            }

            string sourceSql = new StreamReader(sqlFilePath).ReadToEnd();
            string[] sqls = serializeSql(sourceSql);
            SetConnOpen();
            OleDbTransaction tran = conn.BeginTransaction();
            try
            {
                comm = new OleDbCommand();
                comm.Transaction = tran;
                comm.Connection = conn;
                foreach (string s in sqls)
                {
                    var temps = s.Trim().Replace("\r\n", "");
                    if (!string.IsNullOrEmpty(temps))
                    {
                        comm.CommandText = temps;
                        comm.ExecuteNonQuery();
                    }
                }
                tran.Commit();
                return true;
            }
            catch (Exception ex)
            {
                tran.Rollback();
                errorMsg = ex.Message;
                return false;
            }
            finally
            {
                conn.Close();
            }
        }
        /// &lt;summary&gt;
        /// 将sql脚本进行序列化
        /// &lt;/summary&gt;
        /// &lt;param name="sql"&gt;sql脚本&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        private string[] serializeSql(string sql)
        {
            string[] ss = sql.Split(new string[1] { "/*go*/" }, StringSplitOptions.RemoveEmptyEntries);
            return ss;
        }</pre>
<p>执行包含sql语句的文件</p>
<p>其实思路比较简单，就是将sql语句用字符串进行分割，然后将一条条sql语句组合成一个数组，依次进行执行即可。在执行过程中使用事务处理，当错误发生时，能够进行回滚操作。下面是完整代码：</p>
<p>AccessUtils.cs</p>
<p></p>

<pre>  1 using System;
  2 using System.Collections.Generic;
  3 using System.Linq;
  4 using System.Text;
  5 using System.Configuration;
  6 using System.Data.OleDb;
  7 using System.Data.OleDb;
  8 using System.IO;
  9 using System.Data;
 10
 11 namespace AccessRuntime.Bin
 12 {
 13     /// &lt;summary&gt;
 14     /// Access工具类
 15     /// &lt;/summary&gt;
 16     internal sealed class AccessUtils
 17     {
 18         /// &lt;summary&gt;
 19         /// access数据库连接字符串
 20         /// &lt;/summary&gt;
 21         private  string accessConnectionString = string.Empty;
 22         /// &lt;summary&gt;
 23         /// access数据库连接对象
 24         /// &lt;/summary&gt;
 25         private  OleDbConnection conn;
 26         /// &lt;summary&gt;
 27         /// access数据库命令对象
 28         /// &lt;/summary&gt;
 29         private OleDbCommand comm;
 30         /// &lt;summary&gt;
 31         /// access数据库连接字符串
 32         /// &lt;/summary&gt;
 33         public  string AccessConnectionString
 34         {
 35             get {
 36                 if (!string.IsNullOrEmpty(accessConnectionString))
 37                     return accessConnectionString;
 38                 else
 39                 {
 40                     string connstr = ConfigurationManager.ConnectionStrings["AccessRuntimeConnectionString"].ConnectionString;
 41                     if (string.IsNullOrEmpty(connstr))
 42                         throw new ConnectionStringElementNotFindException("未找到或未设置AccessRuntimeConnectionString节点");
 43                     else
 44                         return connstr;
 45                 }
 46             }
 47         }
 48         /// &lt;summary&gt;
 49         /// 初始化连接（有密码）
 50         /// &lt;/summary&gt;
 51         /// &lt;param name="filepath"&gt;可以为空，为空则调用配置文件&lt;/param&gt;
 52         /// &lt;param name="pwd"&gt;数据库密码&lt;/param&gt;
 53         /// &lt;example&gt;
 54         /// public AccessUtils("123",null)
 55         /// &lt;/example&gt;
 56         public AccessUtils(string pwd,string filepath)
 57         {
 58             if (string.IsNullOrEmpty(filepath))
 59             {
 60                 filepath = AccessConnectionString;
 61             }
 62             this.conn = new OleDbConnection(filepath + "; Jet OLEDB:Database Password=" + pwd);
 63             conn.Open();
 64         }
 65
 66         /// &lt;summary&gt;
 67         /// 初始化连接（无密码）
 68         /// &lt;/summary&gt;
 69         /// &lt;param name="filepath"&gt;&lt;/param&gt;
 70         /// &lt;example&gt;
 71         /// 1.public AccessUtils(filepath)
 72         /// 2.public AccessUtils()//不传递参数则调用配置文件
 73         /// &lt;/example&gt;
 74         public AccessUtils(string filepath = null)
 75         {
 76             if (string.IsNullOrEmpty(filepath))
 77             {
 78                 filepath = AccessConnectionString;
 79             }
 80             this.conn = new OleDbConnection(filepath);
 81             conn.Open();
 82         }
 83
 84         /// &lt;summary&gt;
 85         /// 执行sql语句
 86         /// &lt;/summary&gt;
 87         /// &lt;param name="sql"&gt;需要执行的sql语句&lt;/param&gt;
 88         public bool ExecuteSql(string sql, ref string errorMsg)
 89         {
 90             SetConnOpen();
 91             string[] sqls = serializeSql(sql);
 92             OleDbTransaction tran = conn.BeginTransaction();
 93             try
 94             {
 95                 comm = new OleDbCommand();
 96                 comm.Transaction = tran;
 97                 comm.Connection = conn;
 98                 foreach (string s in sqls)
 99                 {
100                     var temps = s.Trim().Replace("\r\n", "");
101                     if (!string.IsNullOrEmpty(temps))
102                     {
103                         comm.CommandText = temps;
104                         comm.ExecuteNonQuery();
105                     }
106                 }
107                 tran.Commit();
108                 return true;
109             }
110             catch(Exception ex)
111             {
112                 tran.Rollback();
113                 errorMsg = ex.Message;
114                 return false;
115             }
116             finally
117             {
118                 conn.Close();
119             }
120         }
121         /// &lt;summary&gt;
122         /// 从sql脚本文件执行
123         /// &lt;/summary&gt;
124         /// &lt;param name="sqlFilePath"&gt;sql脚本文件的路径&lt;/param&gt;
125         /// &lt;returns&gt;&lt;/returns&gt;
126         public bool ExecuteSqlByFile(string sqlFilePath,ref string errorMsg)
127         {
128             if(!File.Exists(sqlFilePath))
129             {
130                 throw new FileNotFoundException("未找到该sql脚本，请检查路径是否错误");
131             }
132
133             string sourceSql = new StreamReader(sqlFilePath).ReadToEnd();
134             string[] sqls = serializeSql(sourceSql);
135             SetConnOpen();
136             OleDbTransaction tran = conn.BeginTransaction();
137             try
138             {
139                 comm = new OleDbCommand();
140                 comm.Transaction = tran;
141                 comm.Connection = conn;
142                 foreach (string s in sqls)
143                 {
144                     var temps = s.Trim().Replace("\r\n", "");
145                     if (!string.IsNullOrEmpty(temps))
146                     {
147                         comm.CommandText = temps;
148                         comm.ExecuteNonQuery();
149                     }
150                 }
151                 tran.Commit();
152                 return true;
153             }
154             catch (Exception ex)
155             {
156                 tran.Rollback();
157                 errorMsg = ex.Message;
158                 return false;
159             }
160             finally
161             {
162                 conn.Close();
163             }
164         }
165         /// &lt;summary&gt;
166         /// 将sql脚本进行序列化
167         /// &lt;/summary&gt;
168         /// &lt;param name="sql"&gt;sql脚本&lt;/param&gt;
169         /// &lt;returns&gt;&lt;/returns&gt;
170         private string[] serializeSql(string sql)
171         {
172             string[] ss = sql.Split(new string[1] { "/*go*/" }, StringSplitOptions.RemoveEmptyEntries);
173             return ss;
174         }
175         /// &lt;summary&gt;
176         /// 获取打开的连接
177         /// &lt;/summary&gt;
178         private void SetConnOpen()
179         {
180             if (this.conn.State != ConnectionState.Open)
181             {
182                 this.conn.Open();
183             }
184         }
185     }
186 }</pre>
<p>AccessUtils.cs</p>
<p>AccessTool.cs 这个是对AccessUtils类的封装，提供了更加友好的方法。</p>
<p></p>

<pre>  1 using System;
  2 using System.Collections.Generic;
  3 using System.Linq;
  4 using System.Text;
  5
  6 namespace AccessRuntime.Bin
  7 {
  8     /// &lt;summary&gt;
  9     /// Access工具
 10     /// 注意：语句之间使用 /*go*/ 进行分割
 11     /// &lt;/summary&gt;
 12     public static class AccessTool
 13     {
 14         /// &lt;summary&gt;
 15         /// 在Access数据库中执行sql语句
 16         /// &lt;/summary&gt;
 17         /// &lt;param name="sql"&gt;sql脚本&lt;/param&gt;
 18         /// &lt;param name="pwd"&gt;数据库密码（如果无密码则不填写此参数）&lt;/param&gt;
 19         /// &lt;returns&gt;执行结果&lt;/returns&gt;
 20         public static bool ExecuteSql(string sql,string pwd = null)
 21         {
 22             AccessUtils au = null;
 23             if (string.IsNullOrEmpty(pwd)) {
 24                 au = new AccessUtils();
 25                 string msg = null;
 26                 if(au.ExecuteSql(sql, ref msg))
 27                 {
 28                     return true;
 29                 }
 30                 else
 31                 {
 32                     throw new AccessRuntimeException(msg);
 33                 }
 34             }
 35             else
 36             {
 37                 au = new AccessUtils(pwd, null);
 38                 string msg = null;
 39                 if(au.ExecuteSql(sql,ref msg))
 40                 {
 41                     return true;
 42                 }
 43                 else
 44                 {
 45                     throw new AccessRuntimeException(msg);
 46                 }
 47             }
 48
 49         }
 50
 51         /// &lt;summary&gt;
 52         /// 在Access数据库中执行sql脚本
 53         /// &lt;/summary&gt;
 54         /// &lt;param name="sqlpath"&gt;sql脚本路径&lt;/param&gt;
 55         /// &lt;param name="pwd"&gt;数据库密码（如果无密码则不填写此参数）&lt;/param&gt;
 56         /// &lt;returns&gt;执行结果&lt;/returns&gt;
 57         public static bool ExecuteSqlByFile(string sqlpath,string pwd = null)
 58         {
 59             AccessUtils au = null;
 60             //判断密码是否填写
 61             if (string.IsNullOrEmpty(pwd))
 62             {
 63                 au = new AccessUtils();
 64                 string msg = null;
 65                 if (au.ExecuteSqlByFile(sqlpath, ref msg))
 66                 {
 67                     return true;
 68                 }
 69                 else
 70                 {
 71                     throw new AccessRuntimeException(msg);
 72                 }
 73             }
 74             else
 75             {
 76                 au = new AccessUtils(pwd, null);
 77                 string msg = null;
 78                 if (au.ExecuteSqlByFile(sqlpath, ref msg))
 79                 {
 80                     return true;
 81                 }
 82                 else
 83                 {
 84                     throw new AccessRuntimeException(msg);
 85                 }
 86             }
 87         }
 88
 89         /// &lt;summary&gt;
 90         /// 在指定Access数据库中执行sql语句
 91         /// &lt;/summary&gt;
 92         /// &lt;param name="sql"&gt;sql脚本&lt;/param&gt;
 93         /// &lt;param name="dbpath"&gt;数据库所在路径&lt;/param&gt;
 94         /// &lt;param name="pwd"&gt;执行结果&lt;/param&gt;
 95         /// &lt;returns&gt;&lt;/returns&gt;
 96         public static bool OnExecuteSql(string sql,string dbpath,string pwd = null)
 97         {
 98             AccessUtils au = null;
 99             if (string.IsNullOrEmpty(pwd))
100             {
101                 au = new AccessUtils(dbpath);
102                 string msg = null;
103                 if (au.ExecuteSql(sql, ref msg))
104                 {
105                     return true;
106                 }
107                 else
108                 {
109                     throw new AccessRuntimeException(msg);
110                 }
111             }
112             else
113             {
114                 au = new AccessUtils(pwd, dbpath);
115                 string msg = null;
116                 if (au.ExecuteSql(sql, ref msg))
117                 {
118                     return true;
119                 }
120                 else
121                 {
122                     throw new AccessRuntimeException(msg);
123                 }
124             }
125
126         }
127
128         /// &lt;summary&gt;
129         /// 在指定Access数据库中执行sql语句
130         /// &lt;/summary&gt;
131         /// &lt;param name="sqlpath"&gt;sql脚本路径&lt;/param&gt;
132         /// &lt;param name="dbpath"&gt;数据库所在路径&lt;/param&gt;
133         /// &lt;param name="pwd"&gt;执行结果&lt;/param&gt;
134         /// &lt;returns&gt;&lt;/returns&gt;
135         public static bool OnExecuteSqlByFile(string sqlpath, string dbpath, string pwd = null)
136         {
137             AccessUtils au = null;
138             //判断密码是否填写
139             if (string.IsNullOrEmpty(pwd))
140             {
141                 au = new AccessUtils(dbpath);
142                 string msg = null;
143                 if (au.ExecuteSqlByFile(sqlpath, ref msg))
144                 {
145                     return true;
146                 }
147                 else
148                 {
149                     throw new AccessRuntimeException(msg);
150                 }
151             }
152             else
153             {
154                 au = new AccessUtils(pwd, dbpath);
155                 string msg = null;
156                 if (au.ExecuteSqlByFile(sqlpath, ref msg))
157                 {
158                     return true;
159                 }
160                 else
161                 {
162                     throw new AccessRuntimeException(msg);
163                 }
164             }
165         }
166     }
167 }</pre>
<p>AccessToo.cs</p>
<p>本工具中还定义了两个自定义的异常类：AccessRuntimeException.cs，ConnectionStringElementNotFindException.cs，下付代码：</p>
<p></p>

<pre>using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AccessRuntime.Bin
{
    /// &lt;summary&gt;
    /// AccessRuntime异常
    /// &lt;/summary&gt;
    public class AccessRuntimeException:Exception
    {
        /// &lt;summary&gt;
        /// 配置文件节点未找到
        /// &lt;/summary&gt;
        public AccessRuntimeException()
        {

        }
        /// &lt;summary&gt;
        /// 配置文件节点未找到
        /// &lt;/summary&gt;
        /// &lt;param name="message"&gt;异常信息&lt;/param&gt;
        public AccessRuntimeException(string message):base(message)
        {

        }
        /// &lt;summary&gt;
        ///
        /// &lt;/summary&gt;
        /// &lt;param name="message"&gt;异常信息&lt;/param&gt;
        /// &lt;param name="inner"&gt;异常类&lt;/param&gt;
        public AccessRuntimeException(string message, Exception inner)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;: base(message, inner)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{ }
    }
}</pre>
<p>AccessRuntimeException.cs</p>
<p></p>

<pre> 1 using System;
 2 using System.Collections.Generic;
 3 using System.Linq;
 4 using System.Text;
 5
 6 namespace AccessRuntime.Bin
 7 {
 8     /// &lt;summary&gt;
 9     /// 配置文件节点未找到
10     /// &lt;/summary&gt;
11     internal class ConnectionStringElementNotFindException:Exception
12     {
13         /// &lt;summary&gt;
14         /// 配置文件节点未找到
15         /// &lt;/summary&gt;
16         public ConnectionStringElementNotFindException()
17         {
18
19         }
20         /// &lt;summary&gt;
21         /// 配置文件节点未找到
22         /// &lt;/summary&gt;
23         /// &lt;param name="message"&gt;异常信息&lt;/param&gt;
24         public ConnectionStringElementNotFindException(string message):base(message)
25         {
26
27         }
28         /// &lt;summary&gt;
29         ///
30         /// &lt;/summary&gt;
31         /// &lt;param name="message"&gt;异常信息&lt;/param&gt;
32         /// &lt;param name="inner"&gt;异常类&lt;/param&gt;
33         public ConnectionStringElementNotFindException(string message, Exception inner)
34 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;: base(message, inner)
35 &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{ }
36     }
37 }</pre>
<p>ConnectionStringElementNotFindException.cs</p>
<p>注意：</p>
<p>1.使用本代码时，需要配置config文件，需要添加AccessRuntimeConnectionString的ConnectionString节点，进行Access数据库配置，当然你也可以根据自己的需要进行调整。</p>
<p>2.在本工具中各个sql语句间使用/*go*/进行分隔，类似mssql中的go（批处理）一样。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-22 09:36:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e8%bf%87%e7%a8%8b/" title="过程">过程</a>, <a href="https://www.biecuoliao.com/tag/namespace/" title="namespace">namespace</a>, <a href="https://www.biecuoliao.com/tag/sed/" title="sed">sed</a>, <a href="https://www.biecuoliao.com/tag/none/" title="none">none</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6%e7%9a%84/" title="文件的">文件的</a>, <a href="https://www.biecuoliao.com/tag/oid/" title="oid">oid</a>, <a href="https://www.biecuoliao.com/tag/mssql/" title="mssql">mssql</a>, <a href="https://www.biecuoliao.com/tag/nop/" title="nop">nop</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae%e5%ba%93%e8%bf%9e%e6%8e%a5/" title="数据库连接">数据库连接</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>.net(C#)在Access数据库中执行sql脚本的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RDLb74.html" rel="bookmark">InstallShield在MySQL和Oracle中执行SQL脚本的方法InstallShield在MySQL和Oracle中执行SQL脚本的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简述 InstallShield已经内建了对MySQL和Oracle的支持.但是这个功能是通过ODBC实现的,它对SQL脚本的格式要求非常严格,因此已经通过官方客户端测试的脚本在IS中执行时往往就会报错. 一般来说,数据库脚本只保证通过官方客户端测试即可,同时维护一份供IS执行的脚本费时费力.因此,考虑安装程序对两数据库的支持通过官方客户端实现. MySQL   function InstallMySQLComponent(szComponent) NUMBER nResult; STRING			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Y7APN4.html" rel="bookmark">Python中执行sql脚本时GO语句出错问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				sql脚本: --创建链接服务器 (其中db2server是DB2的ip地址或服务器名)exec sp_addlinkedserver 'srv_lnk', '', 'SQLOLEDB','10.138.60.94'exec sp_addlinkedsrvlogin 'srv_lnk','false',null,'sa','123456' Go--数据导入(表B存在) --Insert into srv_lnk.sys.Estamp.EstampConfig(field1,field2)INSE			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ORJVK0.html" rel="bookmark">2016&period;1&period;23 通过cmd在程序中执行sql脚本</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				System.Diagnostics.Process pro = new System.Diagnostics.Process(); pro.StartInfo.FileName = &quot;cmd.exe&quot;; pro.StartInfo.UseShellExecute = false; pro.StartInfo.RedirectStandardInput = true; pro.StartInfo.RedirectStandardOutput = true; pro.StartInfo.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzZAodM.html" rel="bookmark">mysql数据库批量执行sql文件对数据库进行操作【windows版本】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				起因: 因工作需要,在本机测试环境升级mysql数据库,需逐条执行mysql数据库的sql文件对数据库进行升级,因此找了些关于mysql的文章,对批量升级数据库所需的sql文件进行升级. 整理思路: 首先,需要对所需升级的sql所在目录的sql文件进行遍历.生成新的批量执行sql文件.想到是windows系统安装的mysql,首先想到使用bat进行sql文件的生成: 生成sql文件后,还需要使用bat文件连接到数据库,并使用新生成的sql文件进行升级. 想到升级的过程中还有可能字符集出现问题,因			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLnK6A3.html" rel="bookmark">用SQL语句创建和删除Access数据库中的表&semi;添加列和删除列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用SQL语句创建和删除Access数据库中的表;添加列和删除列 Posted on 2009-08-11 13:42 yunbo 阅读(1240) 评论(0) 编辑 收藏 用SQL语句创建和删除Access数据库中的表;添加列和删除列SQL语句,具体使用方法请看帮助          Create    Table    tab1    (fld1    integer)      Drop    Table    tab1          Alter    Table    tab1   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qw6ANM.html" rel="bookmark">在SQL Server数据库中执行存储过程很快，在c&num;中调用很慢的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				记录工作中遇到的问题,分享出来: 原博客地址:https://blog.csdn.net/weixin_40782680/article/details/85038281 今天遇到一个比较郁闷的问题,如下图: 点击库存或者点击销售,查询数据很慢,有的将近几十秒,查询数据用的是存储过程,在数据库中执行存储过程,查询数据是很快的,速度非常理想,1秒不到,但是c#程序中调用就要很久. 百度了很多,后来这上面的那篇文章中找到了原因所在: 原因分析:由于存储过程是预编译的, 在第一次执行的时候, 会生成执			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPXkdnM.html" rel="bookmark">获取ACCESS数据库中自增变量的值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/// &lt;summary&gt; /// 获取自增变量值 /// &lt;/summary&gt; /// &lt;returns&gt;自增变量值&lt;/returns&gt; public int getReturnIdentity() { //Conn_Open(); string strCMDtext = @&quot;select @@identity&quot;; OleDbCommand cmd_sql = new OleDbCommand(strCMDtext, conn_1);			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qaaPN3.html" rel="bookmark">在phpmyadmin中执行sql语句出现的错误：Unknown storage engine &amp;&num;39&semi;InnoDB&amp;&num;39&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在phpmyadmin中执行sql语句出现的错误:Unknown storage engine 'InnoDB' 解决方法:解决方法:             1.关闭MySQL数据库       2.修改my.ini文件,把skip-innodb这行注释掉       3.打开MySQL数据库 原因:没有开启MySQL InnoDB存储引擎. 在phpmyadmin中执行sql语句出现的错误:Unknown storage engine 'InnoDB'			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38bZvlM.html" rel="bookmark">Shell脚本中执行sql语句操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这篇文章主要介绍了Shell脚本中执行sql语句操作mysql的5种方法,本文讲解了将SQL语句直接嵌入到shell脚本文件中.命令行调用单独的SQL文件.使用管道符调用SQL文件等方法,需要的朋友可以参考下 对于自动化运维,诸如备份恢复之类的,DBA经常需要将SQL语句封装到shell脚本.本文描述了在Linux环境下mysql数据库中,shell脚本下调用sql语句的几种方法,供大家参考.对于脚本输出的结果美化,需要进一步完善和调整.以下为具体的示例及其方法. 1.将SQL语句直接嵌入到sh			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Ygpaw4.html" rel="bookmark" class="title">关于OC中的几种代码延迟执行方式</a>
					<div>
						第一种: [UIView animateWithDuration:3 delay:3 options:1 animations:^{ self.btn.transform = CGAffineTran ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQJdl3.html" rel="bookmark" class="title">移动三大平台和三大开发模式对比分析</a>
					<div>
						一:移动三大平台及其对比分析: 1)移动三大平台 2)移动三大平台对比分析 二:三大开发模式及其对比分析: 1)三大开发模式 2)三大开发模式对比分析 移动三大平台和三大开发模式对比分析,布布扣,bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5XE7M.html" rel="bookmark" class="title">js技巧</a>
					<div>
						1.文档入口函数 window.onload = function () { //code 将会在页面的全部代码执行完成之后再去执行. } 2.弹窗   alert()   警告窗   confirm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49byZpM.html" rel="bookmark" class="title">【转】iOS&colon;堆&lpar;heap&rpar;和栈&lpar;stack&rpar;的理解--简介</a>
					<div>
						Objective-C的对象在内存中是以堆的方式分配空间的,并且堆内存是由你释放的,即release 栈由编译器管理自动释放的,在方法中(函数体)定义的变量通常是在栈内,因此如果你的变量要跨函数的话就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NzNW84.html" rel="bookmark" class="title">140824●语句应用举例</a>
					<div>
						//降序排序 Console.Write(&quot;请输入数据的个数:&quot;); int n = Convert.ToInt32(Console.ReadLine()); int []sz=n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61kQJ4.html" rel="bookmark" class="title">Phonegap 通信原理</a>
					<div>
						下图为JavaScript调用本地代码的通信过程 Phonegap的核心API都是基于插件的,这些JavaScript API都会调用cordova.exec() 函数来完成操作.cordova.ex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nvojo0.html" rel="bookmark" class="title">IE6&sol;IE7&sol;IE8兼容H5标签</a>
					<div>
						可以使用html5shiv(html5shiv主要解决HTML5提出的新元素不被IE6-8识别,这些新元素不能作为父节点包裹子元素,并且不能应用CSS样式)来解决 &lt;!--[if lt IE 9 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylO8Y4.html" rel="bookmark" class="title">【JAVA】判断当前日期是否在时间点内</a>
					<div>
						public static boolean isInDate(Date date, String strDateBegin, String strDateEnd) { SimpleDateFormat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQR7PM.html" rel="bookmark" class="title">开发中 常用 js 记录（一）</a>
					<div>
						(1)获得URL参数 function GetQueryString(&quot;url参数名&quot;) {     var reg = new RegExp(&quot;(^|&amp;)&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOjzy0.html" rel="bookmark" class="title">mysql 更改密码</a>
					<div>
						$ ln -s /usr/local/mysql/bin/mysql /bin/mysql     #创建mysql软链接,实现通过程序名启动. $ mysql                     ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xvDdN4.html" rel="bookmark" class="title">MIUI7，Android版本5&period;0&period;2，一个程序发送自定义广播，另一个程序没有接收到</a>
					<div>
						对照&lt;第一行代码——Android&gt;进行学习,第五章中说到广播包的相关知识,前面获取广播等程序例程都可以跑的通,但是在5.3.2节中,程序A发送自定义广播,并接收自定义广播,同时程序B也接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rZKrv3.html" rel="bookmark" class="title">MySQL系列之D------MySQL多实例安装安装</a>
					<div>
						D.1   多实例结构 D.2   多实例安装 D.2.1依赖包 # yum install ncurses-devel -y # yum install libaio-devel -y D.2.2通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQWnRM.html" rel="bookmark" class="title">智能无线交通信号控制系统方案</a>
					<div>
						前言   随着城市车辆数目的急剧增长,车辆与路面的矛盾越来越突出,城市交通拥挤和堵塞导致道路的容量和管理效率降低 ,也是交通污染和事故的间接因素.尽管造成这种现象的原因很多 ,但各交叉口交通信号的不协 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Zvqa0.html" rel="bookmark" class="title">10-2&lbrack;RF&rsqb; OOB validation</a>
					<div>
						main idea: 在使用bootstrap生成gi的训练集时,会有一部分数据没有被选中,使用这一部分数据(OOB)进行validation. 1.数据没有被选中的概率 假设训练集大小为N,使用bo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rznm93.html" rel="bookmark" class="title">PHP 多维数组 Key Value的使用</a>
					<div>
						&lt;?php $user[&quot;60&quot;] = array(&quot;id&quot; =&gt; &quot;60&quot;, &quot;num&quot; =&gt; &q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xajnj3.html" rel="bookmark" class="title">最长单调递减子序列</a>
					<div>
						问题描述:求一个数组的最长递减子序列 比如{9,4,3,2,5,4,3,2}的最长递减子序列为{9,5,4,3,2}. 思路:这是一个标准的动态规划的问题,在不理解算法的时候,最感觉可以使用递归的思想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNoELM.html" rel="bookmark" class="title">使用python&plus;hadoop-streaming编写hadoop处理程序</a>
					<div>
						Hadoop Streaming提供了一个便于进行MapReduce编程的工具包,使用它可以基于一些可执行命令.脚本语言或其他编程语言来实现Mapper和 Reducer,从而充分利用Hadoop并行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mobnnw4.html" rel="bookmark" class="title">《需求工程-软件建模与分析之读书笔记之一》</a>
					<div>
						软件需求位于软件工程的起始阶段,是软件系统开发中一个重要的独立工作阶段,为软件工程后续阶段提供了工作基础,对软件项目的成败至关重要.本书是关于软件需求工程的专项著述,系统地介绍需求工程中的最新发展,指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRXdV0.html" rel="bookmark" class="title">Redis 数据备份与恢复命令</a>
					<div>
						Redis SAVE 命令用于创建当前数据库的备份. 语法 redis Save 命令基本语法如下: redis 127.0.0.1:6379&gt; SAVE 实例 redis 127.0.0.1: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNr2x0.html" rel="bookmark" class="title">王爽&amp;lt&semi;&amp;lt&semi;汇编语言&amp;gt&semi;&amp;gt&semi;  实验十四</a>
					<div>
						1 ;以&quot;年/月/日 时:分:秒&quot;的格式, 显示当前的日期, 时间 2 assume cs:code 3 code segment 4 main: 5 mov al,9 6 out ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
